package main

import (
	"git.nspix.com/golang/micro"
	"git.nspix.com/golang/micro/gateway"
	"git.nspix.com/golang/micro/log"
)

type (
	mathRequest struct {
		NumA int `json:"num_a"`
		NumB int `json:"num_b"`
	}

	mathResponse struct {
		Value int `json:"value"`
	}
)

func main() {
	svr := micro.New(micro.WithName("test", "0.1.01"))
	svr.Handle("math.add", func(ctx gateway.Context) (err error) {
		var req mathRequest
		if err = ctx.Bind(&req); err == nil {
			return ctx.Success(mathResponse{Value: req.NumA + req.NumB})
		} else {
			return ctx.Error(100, err.Error())
		}
	},micro.WithHttpMethod("GET"))
	log.Debug(svr.Run())
}
