package main

import (
	"context"
	"fmt"
	"git.nspix.com/micro/internal/micro"
	"github.com/micro/go-micro/v2/util/log"
)

type (
	Math struct{}

	MathRequest struct {
		Num  int
		Num2 int
	}

	MathResponse struct {
		Val int
	}
)

func main() {
	s := micro.New(
		micro.WithName("aa", "1.0.1"),
	)
	args := &MathRequest{
		Num:  10,
		Num2: 20,
	}
	if req, err := s.NewRequest("test.server", "Math.Add", args); err != nil {
		log.Fatal(err)
	} else {
		res := &MathResponse{}
		if err = req.Do(context.Background(), res); err == nil {
			fmt.Println(res.Val)
		} else {
			fmt.Println(err)
		}
	}
	fmt.Println(s.Run())
}
