package micro

import (
	"context"
	"git.nspix.com/golang/micro/gateway"
	"git.nspix.com/golang/micro/log"
)

type (
	HandleOptions struct {
		HttpMethod string
	}

	HandleOption func(o *HandleOptions)

	HandleFunc func(ctx gateway.Context) (err error)

	Application interface {
		Logger() log.Logger                                                 //获取日志实例
		RegisterHandle(method string, cb HandleFunc) (err error)            //注册一个处理器
		NewRequest(service, method string, payload interface{}) (err error) //创建一个rpc请求
	}

	Server interface {
		Start(ctx context.Context) (err error)
		Stop() (err error)
	}
)

func WithHttpMethod(method string) HandleOption {
	return func(o *HandleOptions) {
		o.HttpMethod = method
	}
}
