package registry

var (
	DefaultRegistry Registry
)

type (
	Registry interface {
		Register(instance *ServiceNode) (err error)
		Deregister(instance *ServiceNode) (err error)
		Get(name string) ([]*ServiceNode, error)
		Fetch() ([]*ServiceNode, error)
	}
)

func init() {
	DefaultRegistry = newDiscovery()
}
